# Asterisk Project : Asterisk 13 Function_TALK_DETECT

Created by wikibot on Aug 08, 2014

# TALK_DETECT()

### Synopsis

Raises notifications when Asterisk detects silence or talking on a channel.

### Description

The TALK_DETECT function enables events on the channel it is applied to. These events can be emited over AMI, ARI, and potentially other Asterisk modules that listen for the internal notification.

The function has two parameters that can optionally be passed when `set` on a channel: dsp_talking_threshold and dsp_silence_threshold.

dsp_talking_threshold is the time in milliseconds of sound above what the dsp has established as base line silence for a user before a user is considered to be talking. By default, the value of silencethreshold from dsp.conf is used. If this value is set too tight events may be falsely triggered by variants in room noise.

Valid values are 1 through 2^31.

dsp_silence_threshold is the time in milliseconds of sound falling within what the dsp has established as baseline silence before a user is considered be silent. If this value is set too low events indicating the user has stopped talking may get falsely sent out when the user briefly pauses during mid sentence.

The best way to approach this option is to set it slightly above the maximum amount of ms of silence a user may generate during natural speech.

By default this value is 2500ms. Valid values are 1 through 2^31.

Example:

same => n,Set(TALK_DETECT(set)=) ; Enable talk detection

same => n,Set(TALK_DETECT(set)=1200) ; Update existing talk detection's silence threshold to 1200 ms

same => n,Set(TALK_DETECT(remove)=) ; Remove talk detection

same => n,Set(TALK_DETECT(set)=,128) ; Enable and set talk threshold to 128

This function will set the following variables:

Note

Icon

The TALK_DETECT function uses an audiohook to inspect the voice media frames on a channel. Other functions, such as JITTERBUFFER, DENOISE, and AGC use a similar mechanism. Audiohooks are processed in the order in which they are placed on the channel. As such, it typically makes sense to place functions that modify the voice media data prior to placing the TALK_DETECT function, as this will yield better results.

Example:

same => n,Set(DENOISE(rx)=on) ; Denoise received audio

same => n,Set(TALK_DETECT(set)=) ; Perform talk detection on the denoised received audio

### Syntax

    TALK_DETECT(action)

##### Arguments

- `action`
  - `remove` - W/O. Remove talk detection from the channel.
  - `set` - W/O. Enable TALK_DETECT and/or configure talk detection parameters. Can be called multiple times to change parameters on a channel with talk detection already enabled.
    - `dsp_silence_threshold` - The time in milliseconds before which a user is considered silent.
    - `dsp_talking_threshold` - The time in milliseconds after which a user is considered talking.

### See Also

### Import Version

This documentation was imported from Asterisk Version SVN-branch-13-r420538